/* $Id: LADSPAPortDescriptor.cc,v 1.2 2003/08/08 16:19:32 andete Exp $

lemux - LADSPA instrument plugins based on openMSX devices

(c) 2003 Joost Yervante Damad <joost@lumatec.be>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "LADSPAPortDescriptor.hh"

LADSPAPortDescriptor::LADSPAPortDescriptor(const std::string &name, LADSPA_PortDescriptor type, LADSPA_PortRangeHintDescriptor rangehintdesc, LADSPA_Data lowerbound, LADSPA_Data upperbound)
:	name(name),
	type(type),
	rangeType(rangehintdesc),
	lowerBound(lowerbound),
	upperBound(upperbound)
{
	range_hint.HintDescriptor = rangehintdesc;
	range_hint.LowerBound = lowerBound;
	range_hint.UpperBound = upperBound;
}

const std::string&  LADSPAPortDescriptor::getName()
{
	return name;
}

const LADSPA_PortDescriptor& LADSPAPortDescriptor::getType()
{
	return type;
}

const LADSPA_PortRangeHint& LADSPAPortDescriptor::getRangeHint()
{
	return range_hint;
}

LADSPAPortDescriptor* newBoolPortDescriptor(const char* name, bool defaultv)
{
	return new LADSPAPortDescriptor
	(
		std::string(name),
	
			LADSPAPortDescriptor::Input   |
			LADSPAPortDescriptor::Control ,
		
			(defaultv?LADSPAPortDescriptor::Default1:LADSPAPortDescriptor::Default0)|
			LADSPAPortDescriptor::Toggled ,

			0
		);
}

LADSPAPortDescriptor* newRangePortDescriptor(const char* name, int min, int max)
{
	return new LADSPAPortDescriptor
		(
			std::string(name),
			
				LADSPAPortDescriptor::Input   |
				LADSPAPortDescriptor::Control ,
			
				LADSPAPortDescriptor::BoundedBelow |
				LADSPAPortDescriptor::BoundedAbove |
				LADSPAPortDescriptor::Default0,

			min,
			max
		);

}
