/* $Id: SCCInstance.hh,v 1.1 2003/08/05 12:57:58 andete Exp $

lemux - LADSPA instrument plugins based on openMSX devices

(c) 2003 Joost Yervante Damad <joost@lumatec.be>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef   __SCCINSTANCE_HH__
#define   __SCCINSTANCE_HH__

#define SCC_PRESET_COUNT (342)

#include "LADSPAPluginInstance.hh"

class SCCInstance: public LADSPAPluginInstance
{
public:
	SCCInstance(unsigned long sampleRate);
	virtual ~SCCInstance();

	virtual void connect_port(unsigned long port, LADSPA_Data* dataLocation);
	virtual void activate();
	virtual void run(unsigned long SampleCount);

private:
	const unsigned long sampleRate;

	// SCC data for one channel:
	char wave[32];				// waveform
	int volAdjustedWave[32];	// waveform with volume calculated
	unsigned int incr;			//
	unsigned int count;			//
	unsigned int freq;			// frequence of tone
	unsigned char volume;		// volume of channel

	const unsigned int realstep;
	unsigned int scctime;

	void reset();

	void calcVolAdjustedWave();

	void updateWave();

	// ladspa ports:
	LADSPA_Data* port_freq;
	LADSPA_Data* port_amp;
	LADSPA_Data* port_preset;
	LADSPA_Data  port_preset_backup;
	LADSPA_Data* port_output;
	// LADSPA_Data* port_byte[32];

	// constants
	static const int GETA_BITS = 22;
	static const int CLOCK_FREQ = 3579545;
	static const unsigned SCC_STEP =
			(unsigned)(((unsigned)(1 << 31)) / (CLOCK_FREQ / 2));


	struct SCCPreset
	{
		char* name;
		signed char shape[32];
	};

	struct SCCPreset presets[SCC_PRESET_COUNT+1];
};

#endif // __SCCINSTANCE_HH__
